"use strict";

var _interopRequire = function (obj) { return obj && obj.__esModule ? obj["default"] : obj; };

var set = _interopRequire(require("101/set"));

var doxme = _interopRequire(require("doxme"));

var gutil = _interopRequire(require("gulp-util"));

var through = require("through2").obj;


var DoxmeError = gutil.PluginError.bind(null, "gulp-doxme");


module.exports = function (settings) {
  return through(function gulpDoxme(file, encoding, done) {
    var data = file.data || (function () {
      try {
        return JSON.parse(file.contents.toString());
      } catch (error) {
        done(new DoxmeError("Input must be a valid JSON file."));
      }
    })();

    var markdown;
    try {
      markdown = doxme(data);
    } catch (error) {
      return done(new DoxmeError("Something went wrong with the doxme call. Here's what doxme says:\n" + error.message));
    }

    done(null, set(file, "contents", new Buffer(markdown)));
  });
};